Index: trunk/src/VBox/ValidationKit/Makefile.kmk
===================================================================
--- trunk/src/VBox/ValidationKit/Makefile.kmk	(revision 89091)
+++ trunk/src/VBox/ValidationKit/Makefile.kmk	(revision 89097)
@@ -170,21 +170,21 @@
  ifdef VBOX_WITH_VALIDATIONKIT_PACKING.$(os).$(arch)
   VBOX_VALIDATIONKIT_FILESPEC += \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/exceptionsR3$(TMP_SUFF_EXE) \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/cpu-alloc-all-mem$(TMP_SUFF_EXE) \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/cpu-numa$(TMP_SUFF_EXE) \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/FsPerf$(TMP_SUFF_EXE) \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/IoPerf$(TMP_SUFF_EXE) \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/NetPerf$(TMP_SUFF_EXE) \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/LoadGenerator$(TMP_SUFF_EXE) \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/loadgeneratorR0.r0 \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/SerialTest$(TMP_SUFF_EXE) \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/TestExecService$(TMP_SUFF_EXE) \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/vts_rm$(TMP_SUFF_EXE) \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/vts_shutdown$(TMP_SUFF_EXE) \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/vts_tar$(TMP_SUFF_EXE) \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/xmmsaving$(TMP_SUFF_EXE)
-  ifdef VBOX_WITH_AUDIO_VALIDATIONKIT
+  	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/exceptionsR3$(TMP_SUFF_EXE) \
+  	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/cpu-alloc-all-mem$(TMP_SUFF_EXE) \
+  	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/cpu-numa$(TMP_SUFF_EXE) \
+  	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/FsPerf$(TMP_SUFF_EXE) \
+  	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/IoPerf$(TMP_SUFF_EXE) \
+  	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/NetPerf$(TMP_SUFF_EXE) \
+  	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/LoadGenerator$(TMP_SUFF_EXE) \
+  	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/loadgeneratorR0.r0 \
+  	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/SerialTest$(TMP_SUFF_EXE) \
+  	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/TestExecService$(TMP_SUFF_EXE) \
+  	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/vts_rm$(TMP_SUFF_EXE) \
+  	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/vts_shutdown$(TMP_SUFF_EXE) \
+  	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/vts_tar$(TMP_SUFF_EXE) \
+  	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/xmmsaving$(TMP_SUFF_EXE)
+  ifn1of ($(os), os2 solaris) ## must match utils/audio/Makefile.kmk
    VBOX_VALIDATIONKIT_FILESPEC += \
-      	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/AudioTest$(TMP_SUFF_EXE)
+   	$$(VBOX_PATH_VALIDATIONKIT.$(os).$(arch))/AudioTest$(TMP_SUFF_EXE)
   endif
  endif
Index: trunk/src/VBox/ValidationKit/utils/Makefile.kmk
===================================================================
--- trunk/src/VBox/ValidationKit/utils/Makefile.kmk	(revision 89091)
+++ trunk/src/VBox/ValidationKit/utils/Makefile.kmk	(revision 89097)
@@ -32,19 +32,16 @@
 #
 include $(PATH_SUB_CURRENT)/TestExecServ/Makefile.kmk
+include $(PATH_SUB_CURRENT)/audio/Makefile.kmk
 include $(PATH_SUB_CURRENT)/cpu/Makefile.kmk
 include $(PATH_SUB_CURRENT)/fs/Makefile.kmk
 include $(PATH_SUB_CURRENT)/misc/Makefile.kmk
 include $(PATH_SUB_CURRENT)/network/Makefile.kmk
-include $(PATH_SUB_CURRENT)/serial/Makefile.kmk
-include $(PATH_SUB_CURRENT)/storage/Makefile.kmk
 ifeq ($(KBUILD_TARGET),win)
  include $(PATH_SUB_CURRENT)/nt/Makefile.kmk
 endif
+include $(PATH_SUB_CURRENT)/serial/Makefile.kmk
+include $(PATH_SUB_CURRENT)/storage/Makefile.kmk
 ifeq ($(KBUILD_TARGET),linux)
  include $(PATH_SUB_CURRENT)/usb/Makefile.kmk
-endif
-
-ifdef VBOX_WITH_AUDIO_VALIDATIONKIT
- include $(PATH_SUB_CURRENT)/audio/Makefile.kmk
 endif
 
Index: trunk/src/VBox/ValidationKit/utils/audio/Makefile.kmk
===================================================================
--- trunk/src/VBox/ValidationKit/utils/audio/Makefile.kmk	(revision 89091)
+++ trunk/src/VBox/ValidationKit/utils/audio/Makefile.kmk	(revision 89097)
@@ -31,5 +31,5 @@
 # Utility to play sine wave to Default Audio Device.
 #
-if 0 # Disabled for now; does not work without WinMM.dll.
+if 0 # Disabled for now; does not work without WinMM.dll import validator files.
  PROGRAMS.win += ntPlayToneWaveX
  ntPlayToneWaveX_TEMPLATE = VBoxValidationKitR3
@@ -44,5 +44,7 @@
 VKAT_PATH_AUDIO = $(PATH_ROOT)/src/VBox/Devices/Audio
 
+ifn1of ($(KBUILD_TARGET), os2 solaris)
 PROGRAMS += AudioTest
+endif
 AudioTest_TEMPLATE = VBoxValidationKitR3
 AudioTest_VBOX_IMPORT_CHECKER.win.x86 = nt4
@@ -79,13 +81,11 @@
 endif
 
-ifeq ($(KBUILD_TARGET),win)
-  AudioTest_SOURCES += \
+AudioTest_SOURCES.win += \
 	$(VKAT_PATH_AUDIO)/DrvHostAudioDSound.cpp \
 	$(VKAT_PATH_AUDIO)/DrvHostAudioWasApi.cpp
- ifdef VBOX_WITH_AUDIO_MMNOTIFICATION_CLIENT
-   AudioTest_DEFS    += VBOX_WITH_AUDIO_MMNOTIFICATION_CLIENT
-   AudioTest_SOURCES += \
-	$(VKAT_PATH_AUDIO)/DrvHostAudioDSoundMMNotifClient.cpp
- endif
+ifdef VBOX_WITH_AUDIO_MMNOTIFICATION_CLIENT
+ AudioTest_DEFS.win    += VBOX_WITH_AUDIO_MMNOTIFICATION_CLIENT
+ AudioTest_SOURCES.win += \
+ 	$(VKAT_PATH_AUDIO)/DrvHostAudioDSoundMMNotifClient.cpp
 endif
 
@@ -101,2 +101,3 @@
 
 include $(FILE_KBUILD_SUB_FOOTER)
+