Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp	(revision 89111)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp	(revision 89137)
@@ -28,7 +28,4 @@
 #include "UIIconPool.h"
 #include "UIVirtualBoxManager.h"
-
-/* Other VBox includes: */
-#include "iprt/cpp/utils.h"
 
 
@@ -553,5 +550,5 @@
 }
 
-void UIChooserItemGlobal::paintBackground(QPainter *pPainter, const QRect &rectangle) const
+void UIChooserItemGlobal::paintBackground(QPainter *pPainter, const QRect &rectangle)
 {
     /* Save painter: */
@@ -562,5 +559,5 @@
 
     /* Selected-item background: */
-    if (model()->selectedItems().contains(unconst(this)))
+    if (model()->selectedItems().contains(this))
     {
         /* Prepare color: */
@@ -655,8 +652,8 @@
 }
 
-void UIChooserItemGlobal::paintFrame(QPainter *pPainter, const QRect &rectangle) const
+void UIChooserItemGlobal::paintFrame(QPainter *pPainter, const QRect &rectangle)
 {
     /* Only selected and/or hovered item should have a frame: */
-    if (!model()->selectedItems().contains(unconst(this)) && !isHovered())
+    if (!model()->selectedItems().contains(this) && !isHovered())
         return;
 
@@ -669,5 +666,5 @@
 
     /* Selected-item frame: */
-    if (model()->selectedItems().contains(unconst(this)))
+    if (model()->selectedItems().contains(this))
         strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHighlightLightnessMin - 40);
     /* Hovered-item frame: */
@@ -689,5 +686,5 @@
 }
 
-void UIChooserItemGlobal::paintGlobalInfo(QPainter *pPainter, const QRect &rectangle) const
+void UIChooserItemGlobal::paintGlobalInfo(QPainter *pPainter, const QRect &rectangle)
 {
     /* Prepare variables: */
@@ -700,5 +697,5 @@
 
     /* Selected or hovered item foreground: */
-    if (model()->selectedItems().contains(unconst(this)) || isHovered())
+    if (model()->selectedItems().contains(this) || isHovered())
     {
         /* Prepare palette: */
@@ -707,5 +704,5 @@
         /* Get background color: */
         const QColor highlight = pal.color(QPalette::Active, QPalette::Highlight);
-        const QColor background = model()->selectedItems().contains(unconst(this))
+        const QColor background = model()->selectedItems().contains(this)
                                 ? highlight.lighter(m_iHighlightLightnessMin)
                                 : highlight.lighter(m_iHoverLightnessMin);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h	(revision 89111)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h	(revision 89137)
@@ -210,9 +210,9 @@
       * @{ */
         /** Paints background using specified @a pPainter and certain @a rectangle. */
-        void paintBackground(QPainter *pPainter, const QRect &rectangle) const;
+        void paintBackground(QPainter *pPainter, const QRect &rectangle);
         /** Paints frame using specified @a pPainter and certain @a rect. */
-        void paintFrame(QPainter *pPainter, const QRect &rectangle) const;
+        void paintFrame(QPainter *pPainter, const QRect &rectangle);
         /** Paints global info using specified @a pPainter and certain @a pOptions. */
-        void paintGlobalInfo(QPainter *pPainter, const QRect &rectangle) const;
+        void paintGlobalInfo(QPainter *pPainter, const QRect &rectangle);
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 89111)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 89137)
@@ -33,7 +33,4 @@
 #include "UIVirtualMachineItemCloud.h"
 #include "UIVirtualMachineItemLocal.h"
-
-/* Other VBox includes: */
-#include "iprt/cpp/utils.h"
 
 
@@ -897,5 +894,5 @@
 }
 
-void UIChooserItemMachine::paintBackground(QPainter *pPainter, const QRect &rectangle) const
+void UIChooserItemMachine::paintBackground(QPainter *pPainter, const QRect &rectangle)
 {
     /* Save painter: */
@@ -906,5 +903,5 @@
 
     /* Selected-item background: */
-    if (model()->selectedItems().contains(unconst(this)))
+    if (model()->selectedItems().contains(this))
     {
         /* Prepare color: */
@@ -999,5 +996,5 @@
         {
             /* Selected-item background: */
-            if (model()->selectedItems().contains(unconst(this)))
+            if (model()->selectedItems().contains(this))
                 backgroundColor = pal.color(QPalette::Active, QPalette::Highlight);
             /* Default background: */
@@ -1012,5 +1009,5 @@
         {
             /* Selected-item background: */
-            if (model()->selectedItems().contains(unconst(this)))
+            if (model()->selectedItems().contains(this))
                 backgroundColor = pal.color(QPalette::Active, QPalette::Highlight);
             /* Default background: */
@@ -1035,8 +1032,8 @@
 }
 
-void UIChooserItemMachine::paintFrame(QPainter *pPainter, const QRect &rectangle) const
+void UIChooserItemMachine::paintFrame(QPainter *pPainter, const QRect &rectangle)
 {
     /* Only selected and/or hovered item should have a frame: */
-    if (!model()->selectedItems().contains(unconst(this)) && !isHovered())
+    if (!model()->selectedItems().contains(this) && !isHovered())
         return;
 
@@ -1049,5 +1046,5 @@
 
     /* Selected-item frame: */
-    if (model()->selectedItems().contains(unconst(this)))
+    if (model()->selectedItems().contains(this))
         strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHighlightLightnessMin - 40);
     /* Hovered-item frame: */
@@ -1071,5 +1068,5 @@
 }
 
-void UIChooserItemMachine::paintMachineInfo(QPainter *pPainter, const QRect &rectangle) const
+void UIChooserItemMachine::paintMachineInfo(QPainter *pPainter, const QRect &rectangle)
 {
     /* Prepare variables: */
@@ -1084,5 +1081,5 @@
 
     /* Selected or hovered item foreground: */
-    if (model()->selectedItems().contains(unconst(this)) || isHovered())
+    if (model()->selectedItems().contains(this) || isHovered())
     {
         /* Prepare palette: */
@@ -1091,5 +1088,5 @@
         /* Get background color: */
         const QColor highlight = pal.color(QPalette::Active, QPalette::Highlight);
-        const QColor background = model()->selectedItems().contains(unconst(this))
+        const QColor background = model()->selectedItems().contains(this)
                                 ? highlight.lighter(m_iHighlightLightnessMin)
                                 : highlight.lighter(m_iHoverLightnessMin);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h	(revision 89111)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h	(revision 89137)
@@ -243,9 +243,9 @@
       * @{ */
         /** Paints background using specified @a pPainter and certain @a rectangle. */
-        void paintBackground(QPainter *pPainter, const QRect &rectangle) const;
+        void paintBackground(QPainter *pPainter, const QRect &rectangle);
         /** Paints frame using specified @a pPainter and certain @a rectangle. */
-        void paintFrame(QPainter *pPainter, const QRect &rectangle) const;
+        void paintFrame(QPainter *pPainter, const QRect &rectangle);
         /** Paints machine info using specified @a pPainter and certain @a rectangle. */
-        void paintMachineInfo(QPainter *pPainter, const QRect &rectangle) const;
+        void paintMachineInfo(QPainter *pPainter, const QRect &rectangle);
     /** @} */
 