Index: trunk/include/VBox/iommu-intel.h
===================================================================
--- trunk/include/VBox/iommu-intel.h	(revision 89235)
+++ trunk/include/VBox/iommu-intel.h	(revision 89236)
@@ -2322,30 +2322,36 @@
  * In accordance with the Intel spec.
  * @{ */
-typedef enum VTDINTRFAULT
+typedef enum VTDIRFAULT
 {
     /** Reserved bits invalid in remappable interrupt. */
-    VTDINTRFAULT_REMAPPABLE_INTR_RSVD = 0x20,
+    VTDIRFAULT_REMAPPABLE_INTR_RSVD = 0x20,
+
     /** Interrupt index for remappable interrupt exceeds table size or referenced
      *  address above host address width (HAW) */
-    VTDINTRFAULT_INTR_INDEX_INVALID = 0x21,
+    VTDIRFAULT_INTR_INDEX_INVALID = 0x21,
+
     /** The IRTE is not present.  */
-    VTDINTRFAULT_IRTE_NOT_PRESENT = 0x22,
+    VTDIRFAULT_IRTE_NOT_PRESENT = 0x22,
     /** Reading IRTE from memory failed. */
-    VTDINTRFAULT_IRTE_READ_FAILED = 0x23,
+    VTDIRFAULT_IRTE_READ_FAILED = 0x23,
     /** IRTE reserved bits invalid for an IRTE with Present bit set. */
-    VTDINTRFAULT_IRTE_PRESENT_RSVD = 0x24,
+    VTDIRFAULT_IRTE_PRESENT_RSVD = 0x24,
+
     /** Compatibility format interrupt (CFI) blocked due to EIME being enabled or CFIs
      *  were disabled. */
-    VTDINTRFAULT_CFI_BLOCKED = 0x25,
+    VTDIRFAULT_CFI_BLOCKED = 0x25,
+
     /** IRTE SID, SVT, SQ bits invalid for an IRTE with Present bit set. */
-    VTDINTRFAULT_IRTE_PRESENT_INVALID = 0x26,
+    VTDIRFAULT_IRTE_PRESENT_INVALID = 0x26,
+
     /** Reading posted interrupt descriptor (PID) failed. */
-    VTDINTRFAULT_PID_READ_FAILED = 0x27,
+    VTDIRFAULT_PID_READ_FAILED = 0x27,
     /** PID reserved bits invalid. */
-    VTDINTRFAULT_PID_RSVD = 0x28,
+    VTDIRFAULT_PID_RSVD = 0x28,
+
     /** Untranslated interrupt requested (without PASID) is invalid. */
-    VTDINTRFAULT_IR_WITHOUT_PASID_INVALID = 0x29
-} VTDINTRFAULT;
-AssertCompileSize(VTDINTRFAULT, 4);
+    VTDIRFAULT_IR_WITHOUT_PASID_INVALID = 0x29
+} VTDIRFAULT;
+AssertCompileSize(VTDIRFAULT, 4);
 /** @} */
 
@@ -2354,113 +2360,113 @@
  * In accordance with the Intel spec.
  * @{ */
-typedef enum VTDADDRFAULT
+typedef enum VTDATFAULT
 {
     /* Legacy root table faults (LRT). */
-    VTDADDRFAULT_LRT_1   = 0x8,
-    VTDADDRFAULT_LRT_2   = 0x1,
-    VTDADDRFAULT_LRT_3   = 0xa,
+    VTDATFAULT_LRT_1   = 0x8,
+    VTDATFAULT_LRT_2   = 0x1,
+    VTDATFAULT_LRT_3   = 0xa,
 
     /* Legacy Context-Table Faults (LCT). */
-    VTDADDRFAULT_LCT_1   = 0x9,
-    VTDADDRFAULT_LCT_2   = 0x2,
-    VTDADDRFAULT_LCT_3   = 0xb,
-    VTDADDRFAULT_LCT_4_0 = 0x3,
-    VTDADDRFAULT_LCT_4_1 = 0x3,
-    VTDADDRFAULT_LCT_4_2 = 0x3,
-    VTDADDRFAULT_LCT_4_3 = 0x3,
-    VTDADDRFAULT_LCT_5   = 0xd,
+    VTDATFAULT_LCT_1   = 0x9,
+    VTDATFAULT_LCT_2   = 0x2,
+    VTDATFAULT_LCT_3   = 0xb,
+    VTDATFAULT_LCT_4_0 = 0x3,
+    VTDATFAULT_LCT_4_1 = 0x3,
+    VTDATFAULT_LCT_4_2 = 0x3,
+    VTDATFAULT_LCT_4_3 = 0x3,
+    VTDATFAULT_LCT_5   = 0xd,
 
     /* Legacy Second-Level Table Faults (LSL). */
-    VTDADDRFAULT_LSL_1   = 0x7,
-    VTDADDRFAULT_LSL_2   = 0xc,
+    VTDATFAULT_LSL_1   = 0x7,
+    VTDATFAULT_LSL_2   = 0xc,
 
     /* Legacy General Faults (LGN). */
-    VTDADDRFAULT_LGN_1_0 = 0x4,
-    VTDADDRFAULT_LGN_1_1 = 0x4,
-    VTDADDRFAULT_LGN_1_2 = 0x4,
-    VTDADDRFAULT_LGN_1_3 = 0x4,
-    VTDADDRFAULT_LGN_2   = 0x5,
-    VTDADDRFAULT_LGN_3   = 0x6,
-    VTDADDRFAULT_LGN_4   = 0xe,
+    VTDATFAULT_LGN_1_0 = 0x4,
+    VTDATFAULT_LGN_1_1 = 0x4,
+    VTDATFAULT_LGN_1_2 = 0x4,
+    VTDATFAULT_LGN_1_3 = 0x4,
+    VTDATFAULT_LGN_2   = 0x5,
+    VTDATFAULT_LGN_3   = 0x6,
+    VTDATFAULT_LGN_4   = 0xe,
 
     /* Root-Table Address Register Faults (RTA). */
-    VTDADDRFAULT_RTA_1_0 = 0x30,
-    VTDADDRFAULT_RTA_1_1 = 0x30,
-    VTDADDRFAULT_RTA_1_2 = 0x30,
-    VTDADDRFAULT_RTA_1_3 = 0x30,
-    VTDADDRFAULT_RTA_2   = 0x31,
-    VTDADDRFAULT_RTA_3   = 0x32,
-    VTDADDRFAULT_RTA_4   = 0x33,
+    VTDATFAULT_RTA_1_0 = 0x30,
+    VTDATFAULT_RTA_1_1 = 0x30,
+    VTDATFAULT_RTA_1_2 = 0x30,
+    VTDATFAULT_RTA_1_3 = 0x30,
+    VTDATFAULT_RTA_2   = 0x31,
+    VTDATFAULT_RTA_3   = 0x32,
+    VTDATFAULT_RTA_4   = 0x33,
 
     /* Scalable-Mode Root-Table Faults (SRT). */
-    VTDADDRFAULT_SRT_1   = 0x38,
-    VTDADDRFAULT_SRT_2   = 0x39,
-    VTDADDRFAULT_SRT_3   = 0x3a,
+    VTDATFAULT_SRT_1   = 0x38,
+    VTDATFAULT_SRT_2   = 0x39,
+    VTDATFAULT_SRT_3   = 0x3a,
 
     /* Scalable-Mode Context-Table Faults (SCT). */
-    VTDADDRFAULT_SCT_1   = 0x40,
-    VTDADDRFAULT_SCT_2   = 0x41,
-    VTDADDRFAULT_SCT_3   = 0x42,
-    VTDADDRFAULT_SCT_4_0 = 0x43,
-    VTDADDRFAULT_SCT_4_1 = 0x43,
-    VTDADDRFAULT_SCT_4_2 = 0x43,
-    VTDADDRFAULT_SCT_5   = 0x44,
-    VTDADDRFAULT_SCT_6   = 0x45,
-    VTDADDRFAULT_SCT_7   = 0x46,
-    VTDADDRFAULT_SCT_8   = 0x47,
-    VTDADDRFAULT_SCT_9   = 0x48,
+    VTDATFAULT_SCT_1   = 0x40,
+    VTDATFAULT_SCT_2   = 0x41,
+    VTDATFAULT_SCT_3   = 0x42,
+    VTDATFAULT_SCT_4_0 = 0x43,
+    VTDATFAULT_SCT_4_1 = 0x43,
+    VTDATFAULT_SCT_4_2 = 0x43,
+    VTDATFAULT_SCT_5   = 0x44,
+    VTDATFAULT_SCT_6   = 0x45,
+    VTDATFAULT_SCT_7   = 0x46,
+    VTDATFAULT_SCT_8   = 0x47,
+    VTDATFAULT_SCT_9   = 0x48,
 
     /* Scalable-Mode PASID-Directory Faults (SPD). */
-    VTDADDRFAULT_SPD_1   = 0x50,
-    VTDADDRFAULT_SPD_2   = 0x51,
-    VTDADDRFAULT_SPD_3   = 0x52,
+    VTDATFAULT_SPD_1   = 0x50,
+    VTDATFAULT_SPD_2   = 0x51,
+    VTDATFAULT_SPD_3   = 0x52,
 
     /* Scalable-Mode PASID-Table Faults (SPT). */
-    VTDADDRFAULT_SPT_1   = 0x58,
-    VTDADDRFAULT_SPT_2   = 0x59,
-    VTDADDRFAULT_SPT_3   = 0x5a,
-    VTDADDRFAULT_SPT_4_0 = 0x5b,
-    VTDADDRFAULT_SPT_4_1 = 0x5b,
-    VTDADDRFAULT_SPT_4_2 = 0x5b,
-    VTDADDRFAULT_SPT_4_3 = 0x5b,
-    VTDADDRFAULT_SPT_4_4 = 0x5b,
-    VTDADDRFAULT_SPT_5   = 0x5c,
-    VTDADDRFAULT_SPT_6   = 0x5d,
+    VTDATFAULT_SPT_1   = 0x58,
+    VTDATFAULT_SPT_2   = 0x59,
+    VTDATFAULT_SPT_3   = 0x5a,
+    VTDATFAULT_SPT_4_0 = 0x5b,
+    VTDATFAULT_SPT_4_1 = 0x5b,
+    VTDATFAULT_SPT_4_2 = 0x5b,
+    VTDATFAULT_SPT_4_3 = 0x5b,
+    VTDATFAULT_SPT_4_4 = 0x5b,
+    VTDATFAULT_SPT_5   = 0x5c,
+    VTDATFAULT_SPT_6   = 0x5d,
 
     /* Scalable-Mode First-Level Table Faults (SFL). */
-    VTDADDRFAULT_SFL_1   = 0x70,
-    VTDADDRFAULT_SFL_2   = 0x71,
-    VTDADDRFAULT_SFL_3   = 0x72,
-    VTDADDRFAULT_SFL_4   = 0x73,
-    VTDADDRFAULT_SFL_5   = 0x74,
-    VTDADDRFAULT_SFL_6   = 0x75,
-    VTDADDRFAULT_SFL_7   = 0x76,
-    VTDADDRFAULT_SFL_8   = 0x77,
-    VTDADDRFAULT_SFL_9   = 0x90,
-    VTDADDRFAULT_SFL_10  = 0x91,
+    VTDATFAULT_SFL_1   = 0x70,
+    VTDATFAULT_SFL_2   = 0x71,
+    VTDATFAULT_SFL_3   = 0x72,
+    VTDATFAULT_SFL_4   = 0x73,
+    VTDATFAULT_SFL_5   = 0x74,
+    VTDATFAULT_SFL_6   = 0x75,
+    VTDATFAULT_SFL_7   = 0x76,
+    VTDATFAULT_SFL_8   = 0x77,
+    VTDATFAULT_SFL_9   = 0x90,
+    VTDATFAULT_SFL_10  = 0x91,
 
     /* Scalable-Mode Second-Level Table Faults (SSL). */
-    VTDADDRFAULT_SSL_1   = 0x78,
-    VTDADDRFAULT_SSL_2   = 0x79,
-    VTDADDRFAULT_SSL_3   = 0x7a,
-    VTDADDRFAULT_SSL_4   = 0x7b,
-    VTDADDRFAULT_SSL_5   = 0x7c,
-    VTDADDRFAULT_SSL_6   = 0x7d,
+    VTDATFAULT_SSL_1   = 0x78,
+    VTDATFAULT_SSL_2   = 0x79,
+    VTDATFAULT_SSL_3   = 0x7a,
+    VTDATFAULT_SSL_4   = 0x7b,
+    VTDATFAULT_SSL_5   = 0x7c,
+    VTDATFAULT_SSL_6   = 0x7d,
 
     /* Scalable-Mode General Faults (SGN). */
-    VTDADDRFAULT_SGN_1   = 0x80,
-    VTDADDRFAULT_SGN_2   = 0x81,
-    VTDADDRFAULT_SGN_3   = 0x82,
-    VTDADDRFAULT_SGN_4_0 = 0x83,
-    VTDADDRFAULT_SGN_4_1 = 0x83,
-    VTDADDRFAULT_SGN_4_2 = 0x83,
-    VTDADDRFAULT_SGN_5   = 0x84,
-    VTDADDRFAULT_SGN_6   = 0x85,
-    VTDADDRFAULT_SGN_7   = 0x86,
-    VTDADDRFAULT_SGN_8   = 0x87,
-    VTDADDRFAULT_SGN_9   = 0x88,
-    VTDADDRFAULT_SGN_10  = 0x89
-} VTDADDRFAULT;
-AssertCompileSize(VTDADDRFAULT, 4);
+    VTDATFAULT_SGN_1   = 0x80,
+    VTDATFAULT_SGN_2   = 0x81,
+    VTDATFAULT_SGN_3   = 0x82,
+    VTDATFAULT_SGN_4_0 = 0x83,
+    VTDATFAULT_SGN_4_1 = 0x83,
+    VTDATFAULT_SGN_4_2 = 0x83,
+    VTDATFAULT_SGN_5   = 0x84,
+    VTDATFAULT_SGN_6   = 0x85,
+    VTDATFAULT_SGN_7   = 0x86,
+    VTDATFAULT_SGN_8   = 0x87,
+    VTDATFAULT_SGN_9   = 0x88,
+    VTDATFAULT_SGN_10  = 0x89
+} VTDATFAULT;
+AssertCompileSize(VTDATFAULT, 4);
 /** @} */
 