Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItem.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItem.cpp	(revision 89222)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItem.cpp	(revision 89237)
@@ -228,5 +228,5 @@
 
 UIChooserItem::UIChooserItem(UIChooserItem *pParent, UIChooserNode *pNode,
-                             int iDefaultValue /* = 100 */, int iHoveredValue /* = 90 */)
+                             int iDefaultValue /* = 0 */, int iHoveredValue /* = 100 */)
     : QIWithRetranslateUI4<QIGraphicsWidget>(pParent)
     , m_pParent(pParent)
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp	(revision 89222)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp	(revision 89237)
@@ -32,10 +32,10 @@
 UIChooserItemGlobal::UIChooserItemGlobal(UIChooserItem *pParent, UIChooserNodeGlobal *pNode)
     : UIChooserItem(pParent, pNode)
-    , m_iDefaultLightnessMin(0)
-    , m_iDefaultLightnessMax(0)
-    , m_iHoverLightnessMin(0)
-    , m_iHoverLightnessMax(0)
-    , m_iHighlightLightnessMin(0)
-    , m_iHighlightLightnessMax(0)
+    , m_iDefaultLightnessStart(0)
+    , m_iDefaultLightnessFinal(0)
+    , m_iHoverLightnessStart(0)
+    , m_iHoverLightnessFinal(0)
+    , m_iHighlightLightnessStart(0)
+    , m_iHighlightLightnessFinal(0)
     , m_iMinimumNameWidth(0)
     , m_iMaximumNameWidth(0)
@@ -327,19 +327,19 @@
 void UIChooserItemGlobal::prepare()
 {
-    /* Colors: */
+    /* Color tones: */
 #ifdef VBOX_WS_MAC
-    m_iHighlightLightnessMin = 105;
-    m_iHighlightLightnessMax = 115;
-    m_iHoverLightnessMin = 115;
-    m_iHoverLightnessMax = 125;
-    m_iDefaultLightnessMin = 125;
-    m_iDefaultLightnessMax = 130;
+    m_iDefaultLightnessStart = 125;
+    m_iDefaultLightnessFinal = 130;
+    m_iHoverLightnessStart = 115;
+    m_iHoverLightnessFinal = 125;
+    m_iHighlightLightnessStart = 105;
+    m_iHighlightLightnessFinal = 115;
 #else /* VBOX_WS_MAC */
-    m_iHighlightLightnessMin = 130;
-    m_iHighlightLightnessMax = 160;
-    m_iHoverLightnessMin = 160;
-    m_iHoverLightnessMax = 190;
-    m_iDefaultLightnessMin = 160;
-    m_iDefaultLightnessMax = 190;
+    m_iDefaultLightnessStart = 160;
+    m_iDefaultLightnessFinal = 190;
+    m_iHoverLightnessStart = 160;
+    m_iHoverLightnessFinal = 190;
+    m_iHighlightLightnessStart = 130;
+    m_iHighlightLightnessFinal = 160;
 #endif /* !VBOX_WS_MAC */
 
@@ -565,6 +565,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHighlightLightnessMax));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHighlightLightnessMin));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHighlightLightnessFinal));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHighlightLightnessStart));
         pPainter->fillRect(rectangle, bgGrad);
 
@@ -602,6 +602,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHoverLightnessMax));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHoverLightnessMin));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHoverLightnessFinal));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHoverLightnessStart));
         pPainter->fillRect(rectangle, bgGrad);
 
@@ -637,6 +637,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iDefaultLightnessMax));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iDefaultLightnessMin));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iDefaultDarknessFinal));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iDefaultDarknessStart));
         pPainter->fillRect(rectangle, bgGrad);
 #else
@@ -667,8 +667,8 @@
     /* Selected-item frame: */
     if (model()->selectedItems().contains(this))
-        strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHighlightLightnessMin - 40);
+        strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHighlightLightnessStart - 40);
     /* Hovered-item frame: */
     else if (isHovered())
-        strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHoverLightnessMin - 50);
+        strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHoverLightnessStart - 40);
 
     /* Create/assign pen: */
@@ -705,6 +705,6 @@
         const QColor highlight = pal.color(QPalette::Active, QPalette::Highlight);
         const QColor background = model()->selectedItems().contains(this)
-                                ? highlight.lighter(m_iHighlightLightnessMin)
-                                : highlight.lighter(m_iHoverLightnessMin);
+                                ? highlight.lighter(m_iHighlightLightnessStart)
+                                : highlight.lighter(m_iHoverLightnessStart);
 
         /* Get foreground color: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h	(revision 89222)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h	(revision 89237)
@@ -219,16 +219,16 @@
     /** @name Item stuff.
       * @{ */
-        /** Holds item minimum default lightness. */
-        int  m_iDefaultLightnessMin;
-        /** Holds item maximum default lightness. */
-        int  m_iDefaultLightnessMax;
-        /** Holds item minimum hover lightness. */
-        int  m_iHoverLightnessMin;
-        /** Holds item maximum hover lightness. */
-        int  m_iHoverLightnessMax;
-        /** Holds item minimum highlight lightness. */
-        int  m_iHighlightLightnessMin;
-        /** Holds item maximum highlight lightness. */
-        int  m_iHighlightLightnessMax;
+        /** Holds item start default lightness. */
+        int  m_iDefaultLightnessStart;
+        /** Holds item final default lightness. */
+        int  m_iDefaultLightnessFinal;
+        /** Holds item start hover lightness. */
+        int  m_iHoverLightnessStart;
+        /** Holds item final hover lightness. */
+        int  m_iHoverLightnessFinal;
+        /** Holds item start highlight lightness. */
+        int  m_iHighlightLightnessStart;
+        /** Holds item final highlight lightness. */
+        int  m_iHighlightLightnessFinal;
 
         /** Holds item pixmap. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp	(revision 89222)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp	(revision 89237)
@@ -48,8 +48,8 @@
     : UIChooserItem(0, pNode)
     , m_pScene(pScene)
-    , m_iBackgroundDarknessStart(115)
-    , m_iBackgroundDarknessFinal(150)
+    , m_iRootBackgroundDarknessStart(0)
+    , m_iRootBackgroundDarknessFinal(0)
     , m_iAdditionalHeight(0)
-    , m_iHeaderDarkness(110)
+    , m_iHeaderDarkness(0)
     , m_pToggleButton(0)
     , m_pNameEditorWidget(0)
@@ -70,8 +70,8 @@
     : UIChooserItem(pParent, pNode)
     , m_pScene(0)
-    , m_iBackgroundDarknessStart(115)
-    , m_iBackgroundDarknessFinal(150)
+    , m_iRootBackgroundDarknessStart(0)
+    , m_iRootBackgroundDarknessFinal(0)
     , m_iAdditionalHeight(0)
-    , m_iHeaderDarkness(110)
+    , m_iHeaderDarkness(0)
     , m_pToggleButton(0)
     , m_pNameEditorWidget(0)
@@ -1045,4 +1045,9 @@
 void UIChooserItemGroup::prepare()
 {
+    /* Color tones: */
+    m_iRootBackgroundDarknessStart = 115;
+    m_iRootBackgroundDarknessFinal = 150;
+    m_iHeaderDarkness = 110;
+
     /* Prepare self: */
     m_nameFont = font();
@@ -1599,9 +1604,7 @@
 
         /* Paint default background: */
-        QColor bcTone1 = backgroundColor.darker(m_iBackgroundDarknessStart);
-        QColor bcTone2 = backgroundColor.darker(m_iBackgroundDarknessFinal);
         QLinearGradient gradientDefault(rect.topRight(), rect.bottomLeft());
-        gradientDefault.setColorAt(0, bcTone1);
-        gradientDefault.setColorAt(1, bcTone2);
+        gradientDefault.setColorAt(0, backgroundColor.darker(m_iRootBackgroundDarknessStart));
+        gradientDefault.setColorAt(1, backgroundColor.darker(m_iRootBackgroundDarknessFinal));
         pPainter->fillRect(rect, gradientDefault);
     }
@@ -1609,7 +1612,7 @@
     {
         /* Prepare color: */
-        const QColor headerColor = QApplication::palette().color(QPalette::Active,
-                                                                 model()->selectedItems().contains(this) ?
-                                                                 QPalette::Highlight : QPalette::Window);
+        const QColor backgroundColor = QApplication::palette().color(QPalette::Active,
+                                                                     model()->selectedItems().contains(this) ?
+                                                                     QPalette::Highlight : QPalette::Window);
 
         /* Prepare variables: */
@@ -1624,6 +1627,6 @@
         /* Prepare top gradient: */
         QLinearGradient tGradient(tRect.bottomLeft(), tRect.topLeft());
-        tGradient.setColorAt(1, headerColor.lighter(100 + (double)animatedValue() / 100 * 30));
-        tGradient.setColorAt(0, headerColor);
+        tGradient.setColorAt(1, backgroundColor.lighter(100 + (double)animatedValue() / 100 * 30));
+        tGradient.setColorAt(0, backgroundColor);
 
         /* Fill top rectangle: */
@@ -1637,5 +1640,5 @@
 
             /* Fill top rectangle: */
-            pPainter->fillRect(bRect, headerColor);
+            pPainter->fillRect(bRect, backgroundColor);
         }
 
@@ -1657,6 +1660,6 @@
                 dragTokenGradient.setFinalStop(dragTokenRect.bottomLeft());
             }
-            dragTokenGradient.setColorAt(0, headerColor.darker(dragTokenDarkness()));
-            dragTokenGradient.setColorAt(1, headerColor.darker(dragTokenDarkness() + 40));
+            dragTokenGradient.setColorAt(0, backgroundColor.darker(dragTokenDarkness()));
+            dragTokenGradient.setColorAt(1, backgroundColor.darker(dragTokenDarkness() + 40));
             pPainter->fillRect(dragTokenRect, dragTokenGradient);
         }
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.h	(revision 89222)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.h	(revision 89237)
@@ -324,8 +324,8 @@
         QString  m_strInfoMachines;
 
-        /** Holds the start background darkness. */
-        int  m_iBackgroundDarknessStart;
-        /** Holds the final background darkness. */
-        int  m_iBackgroundDarknessFinal;
+        /** Holds root start background darkness. */
+        int  m_iRootBackgroundDarknessStart;
+        /** Holds root final background darkness. */
+        int  m_iRootBackgroundDarknessFinal;
 
         /** Holds aditional height. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 89222)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 89237)
@@ -37,10 +37,10 @@
 UIChooserItemMachine::UIChooserItemMachine(UIChooserItem *pParent, UIChooserNodeMachine *pNode)
     : UIChooserItem(pParent, pNode)
-    , m_iDefaultLightnessMin(0)
-    , m_iDefaultLightnessMax(0)
-    , m_iHoverLightnessMin(0)
-    , m_iHoverLightnessMax(0)
-    , m_iHighlightLightnessMin(0)
-    , m_iHighlightLightnessMax(0)
+    , m_iDefaultLightnessStart(0)
+    , m_iDefaultLightnessFinal(0)
+    , m_iHoverLightnessStart(0)
+    , m_iHoverLightnessFinal(0)
+    , m_iHighlightLightnessStart(0)
+    , m_iHighlightLightnessFinal(0)
     , m_iFirstRowMaximumWidth(0)
     , m_iMinimumNameWidth(0)
@@ -546,17 +546,17 @@
     /* Color tones: */
 #ifdef VBOX_WS_MAC
-    m_iHighlightLightnessMin = 105;
-    m_iHighlightLightnessMax = 115;
-    m_iHoverLightnessMin = 115;
-    m_iHoverLightnessMax = 125;
-    m_iDefaultLightnessMin = 145;
-    m_iDefaultLightnessMax = 155;
+    m_iDefaultLightnessStart = 145;
+    m_iDefaultLightnessFinal = 155;
+    m_iHoverLightnessStart = 115;
+    m_iHoverLightnessFinal = 125;
+    m_iHighlightLightnessStart = 105;
+    m_iHighlightLightnessFinal = 115;
 #else /* VBOX_WS_MAC */
-    m_iHighlightLightnessMin = 130;
-    m_iHighlightLightnessMax = 160;
-    m_iHoverLightnessMin = 160;
-    m_iHoverLightnessMax = 190;
-    m_iDefaultLightnessMin = 160;
-    m_iDefaultLightnessMax = 190;
+    m_iDefaultLightnessStart = 160;
+    m_iDefaultLightnessFinal = 190;
+    m_iHoverLightnessStart = 160;
+    m_iHoverLightnessFinal = 190;
+    m_iHighlightLightnessStart = 130;
+    m_iHighlightLightnessFinal = 160;
 #endif /* !VBOX_WS_MAC */
 
@@ -909,6 +909,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHighlightLightnessMax));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHighlightLightnessMin));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHighlightLightnessFinal));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHighlightLightnessStart));
         pPainter->fillRect(rectangle, bgGrad);
 
@@ -946,6 +946,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHoverLightnessMax));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHoverLightnessMin));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHoverLightnessFinal));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHoverLightnessStart));
         pPainter->fillRect(rectangle, bgGrad);
 
@@ -980,6 +980,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iDefaultLightnessMax));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iDefaultLightnessMin));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iDefaultLightnessFinal));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iDefaultLightnessStart));
         pPainter->fillRect(rectangle, bgGrad);
     }
@@ -1047,8 +1047,8 @@
     /* Selected-item frame: */
     if (model()->selectedItems().contains(this))
-        strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHighlightLightnessMin - 40);
+        strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHighlightLightnessStart - 40);
     /* Hovered-item frame: */
     else if (isHovered())
-        strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHoverLightnessMin - 50);
+        strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHoverLightnessStart - 40);
 
     /* Create/assign pen: */
@@ -1089,6 +1089,6 @@
         const QColor highlight = pal.color(QPalette::Active, QPalette::Highlight);
         const QColor background = model()->selectedItems().contains(this)
-                                ? highlight.lighter(m_iHighlightLightnessMin)
-                                : highlight.lighter(m_iHoverLightnessMin);
+                                ? highlight.lighter(m_iHighlightLightnessStart)
+                                : highlight.lighter(m_iHoverLightnessStart);
 
         /* Get foreground color: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h	(revision 89222)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h	(revision 89237)
@@ -259,16 +259,16 @@
     /** @name Item stuff.
       * @{ */
-        /** Holds item minimum default lightness. */
-        int  m_iDefaultLightnessMin;
-        /** Holds item maximum default lightness. */
-        int  m_iDefaultLightnessMax;
-        /** Holds item minimum hover lightness. */
-        int  m_iHoverLightnessMin;
-        /** Holds item maximum hover lightness. */
-        int  m_iHoverLightnessMax;
-        /** Holds item minimum highlight lightness. */
-        int  m_iHighlightLightnessMin;
-        /** Holds item maximum highlight lightness. */
-        int  m_iHighlightLightnessMax;
+        /** Holds item start default lightness. */
+        int  m_iDefaultLightnessStart;
+        /** Holds item final default lightness. */
+        int  m_iDefaultLightnessFinal;
+        /** Holds item start hover lightness. */
+        int  m_iHoverLightnessStart;
+        /** Holds item final hover lightness. */
+        int  m_iHoverLightnessFinal;
+        /** Holds item start highlight lightness. */
+        int  m_iHighlightLightnessStart;
+        /** Holds item final highlight lightness. */
+        int  m_iHighlightLightnessFinal;
 
         /** Holds item pixmap. */