Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp	(revision 89239)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp	(revision 89240)
@@ -329,17 +329,17 @@
     /* Color tones: */
 #ifdef VBOX_WS_MAC
-    m_iDefaultLightnessStart = 125;
-    m_iDefaultLightnessFinal = 130;
-    m_iHoverLightnessStart = 115;
-    m_iHoverLightnessFinal = 125;
-    m_iHighlightLightnessStart = 105;
-    m_iHighlightLightnessFinal = 115;
+    m_iDefaultLightnessStart = 130;
+    m_iDefaultLightnessFinal = 125;
+    m_iHoverLightnessStart = 125;
+    m_iHoverLightnessFinal = 115;
+    m_iHighlightLightnessStart = 115;
+    m_iHighlightLightnessFinal = 105;
 #else /* VBOX_WS_MAC */
-    m_iDefaultLightnessStart = 160;
-    m_iDefaultLightnessFinal = 190;
-    m_iHoverLightnessStart = 160;
-    m_iHoverLightnessFinal = 190;
-    m_iHighlightLightnessStart = 130;
-    m_iHighlightLightnessFinal = 160;
+    m_iDefaultLightnessStart = 190;
+    m_iDefaultLightnessFinal = 160;
+    m_iHoverLightnessStart = 190;
+    m_iHoverLightnessFinal = 160;
+    m_iHighlightLightnessStart = 160;
+    m_iHighlightLightnessFinal = 130;
 #endif /* !VBOX_WS_MAC */
 
@@ -565,6 +565,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHighlightLightnessFinal));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHighlightLightnessStart));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHighlightLightnessStart));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHighlightLightnessFinal));
         pPainter->fillRect(rectangle, bgGrad);
 
@@ -602,6 +602,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHoverLightnessFinal));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHoverLightnessStart));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHoverLightnessStart));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHoverLightnessFinal));
         pPainter->fillRect(rectangle, bgGrad);
 
@@ -637,6 +637,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iDefaultLightnessFinal));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iDefaultLightnessStart));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iDefaultLightnessStart));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iDefaultLightnessFinal));
         pPainter->fillRect(rectangle, bgGrad);
 #else
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 89239)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 89240)
@@ -546,17 +546,17 @@
     /* Color tones: */
 #ifdef VBOX_WS_MAC
-    m_iDefaultLightnessStart = 145;
-    m_iDefaultLightnessFinal = 155;
-    m_iHoverLightnessStart = 115;
-    m_iHoverLightnessFinal = 125;
-    m_iHighlightLightnessStart = 105;
-    m_iHighlightLightnessFinal = 115;
+    m_iDefaultLightnessStart = 155;
+    m_iDefaultLightnessFinal = 145;
+    m_iHoverLightnessStart = 125;
+    m_iHoverLightnessFinal = 115;
+    m_iHighlightLightnessStart = 115;
+    m_iHighlightLightnessFinal = 105;
 #else /* VBOX_WS_MAC */
-    m_iDefaultLightnessStart = 160;
-    m_iDefaultLightnessFinal = 190;
-    m_iHoverLightnessStart = 160;
-    m_iHoverLightnessFinal = 190;
-    m_iHighlightLightnessStart = 130;
-    m_iHighlightLightnessFinal = 160;
+    m_iDefaultLightnessStart = 190;
+    m_iDefaultLightnessFinal = 160;
+    m_iHoverLightnessStart = 190;
+    m_iHoverLightnessFinal = 160;
+    m_iHighlightLightnessStart = 160;
+    m_iHighlightLightnessFinal = 130;
 #endif /* !VBOX_WS_MAC */
 
@@ -909,6 +909,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHighlightLightnessFinal));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHighlightLightnessStart));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHighlightLightnessStart));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHighlightLightnessFinal));
         pPainter->fillRect(rectangle, bgGrad);
 
@@ -946,6 +946,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHoverLightnessFinal));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHoverLightnessStart));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHoverLightnessStart));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHoverLightnessFinal));
         pPainter->fillRect(rectangle, bgGrad);
 
@@ -980,6 +980,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iDefaultLightnessFinal));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iDefaultLightnessStart));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iDefaultLightnessStart));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iDefaultLightnessFinal));
         pPainter->fillRect(rectangle, bgGrad);
     }